﻿# fuelle-viele-tiefensuche-tiefe-liste.py
# Programm zum Füllen von Containern mit Tiefensuche
# (Rucksackproblem)

# Globale Variable für die Stücke:
stuecke=[30,30,30,30,30,20,20,20,20,20]
def erzeuge_Container(fassungsvermoegen):
    return [fassungsvermoegen, []]

def fuelle_ein(stueck, container):
    inhalt=[]+container[1] # echte Kopie erzeugen!
    inhalt.append(stueck)
    return [container[0], inhalt]

### Prädikat zum Testen, ob der Container voll ist.
def ist_voll(container):
    return container[0]==sum(container[1])
def alle_voll(alleContainer):
    for container in alleContainer:
        if not(ist_voll(container)):
            return False
    return True
### ... mit dem Stück zu voll wird.
def wird_zu_voll(stueck, container):
    return container[0]<stueck+sum(container[1])


def fuelle(stuecke, alleContainer):
    ##input(str((stuecke,alleContainer))) # verfolgen
    if alle_voll(alleContainer):
        return alleContainer
    if len(stuecke)==0:
        return False
    # Zunächst mit dem Stück in allen versuchen - wenn es geht
    for i in range(len(alleContainer)):
        if not(wird_zu_voll(stuecke[0], alleContainer[i])):
            ergebnis=fuelle(stuecke[1:],
                            alleContainer[:i]+ # alle davor
                            [fuelle_ein(stuecke[0],alleContainer[i])]+
                            alleContainer[i+1:]) # alle danach
            if ergebnis: return ergebnis
    # In jedem Fall auch ohne das Stück versuchen:
    ergebnis=fuelle(stuecke[1:],alleContainer)
    if ergebnis: return ergebnis
    return False

### Tests:
def ausgabe(stuecke, containerliste):
    print('Stücke:', stuecke, containerliste,
          'Ergebnis:\n', fuelle(stuecke, containerliste), '\n')

#### Beispiele mit zwei Containern
##ausgabe( [30,30,20,20], [erzeuge_Container(50),erzeuge_Container(50)] )
##ausgabe( stuecke, [erzeuge_Container(80),erzeuge_Container(80)] )
##ausgabe( [30,30,30,30],  [erzeuge_Container(100),erzeuge_Container(100)] )
##ausgabe( [30,30,30,30,20,20],  [erzeuge_Container(90),erzeuge_Container(90)] )
##ausgabe( [30,30,30,30,20,20,20],  [erzeuge_Container(90),erzeuge_Container(90)] )
##ausgabe( stuecke,  [erzeuge_Container(90),erzeuge_Container(90)] )
##ausgabe( stuecke,  [erzeuge_Container(100),erzeuge_Container(100)] )


alle=[]
for i in range(6): alle.append(erzeuge_Container(80))
ausgabe( stuecke*2, fuelle(stuecke*2, alle) )

# mit Zeitmessung:
## 3
import time
start=time.perf_counter() # Py 3.x-Variante
alle=[]
for i in range(3): alle.append(erzeuge_Container(50+i*10))
ausgabe( stuecke*2, fuelle(stuecke*2, alle) )
stopp=time.perf_counter()
print(stopp-start)
### -> [[50, [30, 20]], [60, [30, 30]], [70, [30, 20, 20]]]

## 4
start=time.perf_counter()
alle=[]
for i in range(4): alle.append(erzeuge_Container(50+i*10))
ausgabe( stuecke*2, fuelle(stuecke*2, alle))
stopp=time.perf_counter()
print(stopp-start)
### -> [[50, [30, 20]], [60, [30, 30]], [70, [30, 20, 20]], [80, [30, 20, 30]]]

## 5
start=time.perf_counter()
alle=[]
for i in range(5): alle.append(erzeuge_Container(50+i*10))
ausgabe( stuecke*2, fuelle(stuecke*2, alle))
stopp=time.perf_counter()
print(stopp-start)
### -> [[50, [30, 20]], [60, [30, 30]], [70, [30, 20, 20]], [80, [30, 20, 30]],
### [90, [20, 30, 20, 20]]]

#### 6 (dauert sehr lange!)
##start=time.perf_counter()
##alle=[]
##for i in range(6): alle.append(erzeuge_Container(50+i*10))
##ausgabe( stuecke*2, fuelle(stuecke*2, alle))
##stopp=time.perf_counter()
##print(stopp-start)

### beispielhaft gemessene Zeiten:
### 3 :    0.015
### 4 :    0.113
### 5 :   15.972
### 6 : 2210.532    (36 min 50 sec)
